package rocks.zipcode.io.quiz3.arrays;
/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    //fields -- use through out the game
    private String[][] board;
    //create constructor -- same name as class
    public TicTacToe(String[][] board) {
        this.board = board;
    }
    //default constructor
    public TicTacToe() {
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] column = new String[board.length];
        for (int i = 0; i < board.length; i++) {
            column[i] = board[i][value];
        }
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] rowHomogenous = new String[board.length];
        for (int i = 0; i < board.length; i++) {
            if (!(rowHomogenous[i] = board[i][rowIndex]).equals(true)) {
                return true;
            }
        }
        return false;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] colHomogeneous = getColumn(columnIndex);
        for (int i = 0; i < board.length ; i++) {
            if(!(colHomogeneous[i].equals(board[i][columnIndex]))) {
                return true;
            }
        }
        return false;
    }

    public String getWinner() {
        for (int i = 0; i < 3 ; i++) {
            if(isRowHomogenous(i)) {
                return getRow(i)[0];
            }
            if(isColumnHomogeneous(i)){
                return getColumn(i)[0];
            }
        }
        return null;
    }

    public String[][] getBoard() {
        return board;
    }
}
